OpenTTD Source: NWidgetBase Class Reference

OpenTTD Source 14.1

Public Member Functions | Data Fields | Protected Member Functions
NWidgetBase Class Referenceabstract
Hierarchical widgets

Baseclass for nested widgets. More...

`#include <widget_type.h>`

Inheritance diagram for NWidgetBase:

## Public Member Functions
| NWidgetBase (WidgetType tp)
| Base class constructor. More...
virtual void | AdjustPaddingForZoom ()
virtual void | SetupSmallestSize (Window *w)=0
virtual void | AssignSizePosition (SizingType sizing, int x, int y, uint given_width, uint given_height, bool rtl)=0
virtual void | FillWidgetLookup (WidgetLookup &widget_lookup)=0
virtual NWidgetCore * | GetWidgetFromPos (int x, int y)=0
virtual NWidgetBase * | GetWidgetOfType (WidgetType tp)
| Retrieve a widget by its type. More...
template<class NWID >
NWID * | GetParentWidget ()
| Get parent widget of type NWID. More...
template<class NWID >
const NWID * | GetParentWidget () const
| Get parent widget of type NWID. More...
virtual bool | IsHighlighted () const
virtual TextColour | GetHighlightColour () const
virtual void | SetHighlighted ([[maybe_unused]] TextColour highlight_colour)
void | SetPadding (uint8_t top, uint8_t right, uint8_t bottom, uint8_t left)
| Set additional space (padding) around the widget. More...
void | SetPadding (const RectPadding &padding)
| Set additional space (padding) around the widget. More...
uint | GetHorizontalStepSize (SizingType sizing) const
| Get the horizontal sizing step. More...
uint | GetVerticalStepSize (SizingType sizing) const
| Get the vertical sizing step. More...
virtual void | Draw (const Window *w)=0
virtual void | SetDirty (const Window *w) const
| Mark the widget as 'dirty' (in need of repaint). More...
Rect | GetCurrentRect () const
Public Member Functions inherited from ZeroedMemoryAllocator
void * | operator new (size_t size)
| Memory allocator for a single class instance. More...
void * | operator new[] (size_t size)
| Memory allocator for an array of class instances. More...
void | operator delete (void *ptr)
| Memory release for a single class instance. More...
void | operator delete[] (void *ptr)
| Memory release for an array of class instances. More...

## Data Fields
WidgetType | type
| Type of the widget / nested widget.
uint | fill_x
| Horizontal fill stepsize (from initial size, `0` means not resizable).
uint | fill_y
| Vertical fill stepsize (from initial size, `0` means not resizable).
uint | resize_x
| Horizontal resize step (`0` means not resizable).
uint | resize_y
| Vertical resize step (`0` means not resizable).
uint | smallest_x
| Smallest horizontal size of the widget in a filled window.
uint | smallest_y
| Smallest vertical size of the widget in a filled window.
uint | current_x
| Current horizontal size (after resizing).
uint | current_y
| Current vertical size (after resizing).
int | pos_x
| Horizontal position of top-left corner of the widget in the window.
int | pos_y
| Vertical position of top-left corner of the widget in the window.
RectPadding | padding
| Padding added to the widget. Managed by parent container widget. (parent container may swap left and right for RTL)
RectPadding | uz_padding
| Unscaled padding, for resize calculation.
NWidgetBase * | parent
| Parent widget of this widget, automatically filled in when added to container.

## Protected Member Functions
void | StoreSizePosition (SizingType sizing, int x, int y, uint given_width, uint given_height)
| Store size and position. More...

## Detailed Description

Baseclass for nested widgets.

Invariant
  After initialization, .
  After initialization, .

Definition at line 135 of file widget_type.h.

## Constructor & Destructor Documentation

## ◆ NWidgetBase()

NWidgetBase::NWidgetBase | ( | WidgetType | tp | ) |

Base class constructor.

Parameters

  tp | Nested widget type.

Definition at line 851 of file widget.cpp.

References type.

## Member Function Documentation

## ◆ AssignSizePosition()

void NWidgetBase::AssignSizePosition | ( | SizingType | sizing,
|  | int | x,
|  | int | y,
|  | uint | given_width,
|  | uint | given_height,
|  | bool | rtl
| ) |  |
| pure virtual

Assign size and position to the widget.

Parameters

  sizing | Type of resizing to perform.
  x | Horizontal offset of the widget relative to the left edge of the window.
  y | Vertical offset of the widget relative to the top edge of the window.
  given_width | Width allocated to the widget.
  given_height | Height allocated to the widget.
  rtl | Adapt for right-to-left languages (position contents of horizontal containers backwards).

Afterwards, pos_x and pos_y contain the top-left position of the widget, smallest_x and smallest_y contain the smallest size such that all widgets of the window are consistent, and current_x and current_y contain the current size.

Implemented in NWidgetSmallmapDisplay, NWidgetNewGRFDisplay, NWidgetToolbarContainer, NWidgetBackground, NWidgetMatrix, NWidgetVertical, NWidgetHorizontalLTR, NWidgetHorizontal, NWidgetStacked, NWidgetResizeBase, and NWidgetServerListHeader.

## ◆ Draw()

void NWidgetBase::Draw | ( | const Window * | w | ) |
| pure virtual

Draw the widgets of the tree. The function calls Window::DrawWidget for each widget with a non-negative index, after the widget itself is painted.

Parameters

  w | Window that owns the tree.

Implemented in NWidgetNewGRFDisplay, NWidgetToolbarContainer, NWidgetLeaf, NWidgetScrollbar, NWidgetViewport, NWidgetBackground, NWidgetSpacer, NWidgetMatrix, NWidgetStacked, NWidgetContainer, and NWidgetSocialPlugins.

## ◆ FillWidgetLookup()

void NWidgetBase::FillWidgetLookup | ( | WidgetLookup & | widget_lookup | ) |
| pure virtual

Fill the Window::widget_lookup with pointers to nested widgets in the tree.

Parameters

  widget_lookup | The WidgetLookup.

Implemented in NWidgetNewGRFDisplay, NWidgetBackground, NWidgetSpacer, NWidgetMatrix, NWidgetStacked, NWidgetContainer, NWidgetCore, and NWidgetSocialPlugins.

## ◆ GetHorizontalStepSize()

uint NWidgetBase::GetHorizontalStepSize | ( | SizingType | sizing | ) | const
| inline

Get the horizontal sizing step.

Parameters

  sizing | Type of resize being performed.

Definition at line 252 of file widget_type.h.

References fill_x, resize_x, and ST_RESIZE.

## ◆ GetParentWidget() [1/2]

template<class NWID >

NWID* NWidgetBase::GetParentWidget | ( |  | ) |
| inline

Get parent widget of type NWID.

Template Parameters

  NWID | Type of the nested widget.

Returns
  Parent widget, or nullptr if no widget of the specified type is found.

Definition at line 154 of file widget_type.h.

References parent.

## ◆ GetParentWidget() [2/2]

template<class NWID >

const NWID* NWidgetBase::GetParentWidget | ( |  | ) | const
| inline

Get parent widget of type NWID.

Template Parameters

  NWID | Type of the nested widget.

Returns
  Parent widget, or nullptr if no widget of the specified type is found.

Definition at line 168 of file widget_type.h.

References parent.

## ◆ GetVerticalStepSize()

uint NWidgetBase::GetVerticalStepSize | ( | SizingType | sizing | ) | const
| inline

Get the vertical sizing step.

Parameters

  sizing | Type of resize being performed.

Definition at line 261 of file widget_type.h.

References fill_y, resize_y, and ST_RESIZE.

## ◆ GetWidgetFromPos()

NWidgetCore * NWidgetBase::GetWidgetFromPos | ( | int | x,
|  | int | y
| ) |  |
| pure virtual

Retrieve a widget by its position.

Parameters

  x | Horizontal position relative to the left edge of the window.
  y | Vertical position relative to the top edge of the window.

Returns
  Returns the deepest nested widget that covers the given position, or `nullptr` if no widget can be found.

Implemented in NWidgetNewGRFDisplay, NWidgetBackground, NWidgetSpacer, NWidgetMatrix, NWidgetStacked, NWidgetContainer, and NWidgetCore.

## ◆ GetWidgetOfType()

NWidgetBase * NWidgetBase::GetWidgetOfType | ( | WidgetType | tp | ) |
| virtual

Retrieve a widget by its type.

Parameters

  tp | Widget type to search for.

Returns
  Returns the first widget of the specified type, or `nullptr` if no widget can be found.

Reimplemented in NWidgetBackground, and NWidgetContainer.

Definition at line 923 of file widget.cpp.

References type.

Referenced by NWidgetContainer::GetWidgetOfType().

## ◆ SetDirty()

void NWidgetBase::SetDirty | ( | const Window * | w | ) | const
| virtual

Mark the widget as 'dirty' (in need of repaint).

Parameters

  w | Window owning the widget.

Reimplemented in NWidgetSpacer.

Definition at line 903 of file widget.cpp.

References AddDirtyBlock(), current_x, current_y, Window::left, pos_x, pos_y, and Window::top.

Referenced by VehicleListWindow::OnPaint(), Window::SetFocusedWidget(), Window::SetWidgetHighlight(), SmallMapWindow::SmallMapCenterOnCurrentPos(), and Window::UnfocusFocusedWidget().

## ◆ SetPadding() [1/2]

void NWidgetBase::SetPadding | ( | const RectPadding & | padding | ) |
| inline

Set additional space (padding) around the widget.

Parameters

  padding | Amount of padding around the widget.

Definition at line 200 of file widget_type.h.

References padding, and uz_padding.

## ◆ SetPadding() [2/2]

void NWidgetBase::SetPadding | ( | uint8_t | top,
|  | uint8_t | right,
|  | uint8_t | bottom,
|  | uint8_t | left
| ) |  |
| inline

Set additional space (padding) around the widget.

Parameters

  top | Amount of additional space above the widget.
  right | Amount of additional space right of the widget.
  bottom | Amount of additional space below the widget.
  left | Amount of additional space left of the widget.

Definition at line 187 of file widget_type.h.

References uz_padding.

## ◆ SetupSmallestSize()

void NWidgetBase::SetupSmallestSize | ( | Window * | w | ) |
| pure virtual

Compute smallest size needed by the widget.

The smallest size of a widget is the smallest size that a widget needs to display itself properly. In addition, filling and resizing of the widget are computed. The function calls Window::UpdateWidgetSize for each leaf widget and background widget without child with a non-negative index.

Parameters

  w | Window owning the widget.

Note
  After the computation, the results can be queried by accessing the smallest_x and smallest_y data members of the widget.

Implemented in NWidgetSmallmapDisplay, NWidgetScenarioToolbarContainer, NWidgetNewGRFDisplay, NWidgetToolbarContainer, NWidgetLeaf, NWidgetScrollbar, NWidgetViewport, NWidgetBackground, NWidgetSpacer, NWidgetMatrix, NWidgetVertical, NWidgetHorizontal, NWidgetStacked, NWidgetSocialPlugins, and NWidgetServerListHeader.

Referenced by NWidgetSmallmapDisplay::SetupSmallestSize().

## ◆ StoreSizePosition()

void NWidgetBase::StoreSizePosition | ( | SizingType | sizing,
|  | int | x,
|  | int | y,
|  | uint | given_width,
|  | uint | given_height
| ) |  |
| inlineprotected

Store size and position.

Parameters

  sizing | Type of resizing to perform.
  x | Horizontal offset of the widget relative to the left edge of the window.
  y | Vertical offset of the widget relative to the top edge of the window.
  given_width | Width allocated to the widget.
  given_height | Height allocated to the widget.

Definition at line 274 of file widget_type.h.

The documentation for this class was generated from the following files:

- src/widget_type.h
- src/widget.cpp